@echo off
bin\sendmidi list
set MIDIOUT="USB Midi Cable"
set AUDIOIN=0
set NATTLEN=5
set STEP1=Y
set STEP2=Y

if not exist record mkdir record
if not exist sfz mkdir sfz
bin\sendmidi dev %MIDIOUT% dec ch 10 cc 10 0 cc 7 127 cc 11 127 cc 91 0 cc 93 0 panic
bin\sox -q -r 44.1k -c 2 -t waveaudio %AUDIOIN% test.wav remix 1 trim 0 0.5
timeout /t 3 /nobreak
setlocal EnableDelayedExpansion
for %%i in (0 8 16 24 25 32 40 48 56) do (
  set "formattedValue=000000%%i"
  if not exist record\d!formattedValue:~-3! mkdir record\d!formattedValue:~-3!
  if not exist sfz\d!formattedValue:~-3! mkdir sfz\d!formattedValue:~-3!
  if %STEP1% == Y (
    for /l %%j in (27, 1, 87) do (
	  call :recpatch !formattedValue:~-3! 0%%j 7
	)
  )
  if %STEP2% == Y (
    call :trimpatch !formattedValue:~-3!
  )
)
goto :eof

:recpatch
echo Recording patch:d%~1 note:%~2 ....
bin\sendmidi dev %MIDIOUT% dec ch 10 cc 0 127 cc 32 0 pc %~1
start bin\sox -r 44.1k -c 2 -t waveaudio %AUDIOIN% record\d%~1\d%~1n%~2.wav remix 1 trim 0 %~3
ping 2.2.2.2 -n 1 -w 1000 > nul
bin\sendmidi dev %MIDIOUT% dec ch 10 on %~2 127
ping 2.2.2.2 -n 1 -w 500 > nul
timeout /t %~3 /nobreak
bin\sendmidi dev %MIDIOUT% dec ch 10 off %~2 panic
ping 2.2.2.2 -n 1 -w 500 > nul
bin\sendmidi dev %MIDIOUT% dec ch 10 off %~2
bin\sox -q -r 44.1k -c 2 -t waveaudio %AUDIOIN% test.wav remix 1 trim 0 0.5
ping 2.2.2.2 -n 1 -w 500 > nul
exit /b

:trimpatch
echo Trimming patch:d%~1 ....
for /f %%f in ('dir /b/o-n record\d%~1\*.wav') do (
  bin\sox record\d%~1\%%f sfz\d%~1\%%f silence 1 0.01 0.2 -1 0.1 0.02 trim 0 !NATTLEN!
)
exit /b
