@echo off
bin\sendmidi list
set MIDIOUT="USB Midi Cable"
set AUDIOIN=0
set NATTLEN=5
set STEP1=Y
set STEP2=Y

if not exist record mkdir record
if not exist sfz mkdir sfz
bin\sendmidi dev %MIDIOUT% dec cc 10 0 cc 7 127 cc 11 127 cc 91 0 cc 93 0 panic
bin\sox -q -r 44.1k -c 2 -t waveaudio %AUDIOIN% test.wav remix 1 trim 0 0.5
timeout /t 3 /nobreak
setlocal EnableDelayedExpansion
for /l %%i in (0, 1, 127) do (
  set "formattedValue=000000%%i"
  if not exist record\!formattedValue:~-3! mkdir record\!formattedValue:~-3!
  if not exist sfz\!formattedValue:~-3! mkdir sfz\!formattedValue:~-3!
  if %STEP1% == Y (
    call :recpatch !formattedValue:~-3! 024 18
    call :recpatch !formattedValue:~-3! 036 17
    call :recpatch !formattedValue:~-3! 048 16
    call :recpatch !formattedValue:~-3! 054 15
    call :recpatch !formattedValue:~-3! 060 14
    call :recpatch !formattedValue:~-3! 066 13
    call :recpatch !formattedValue:~-3! 072 12
    call :recpatch !formattedValue:~-3! 078 11
    call :recpatch !formattedValue:~-3! 084 09
    call :recpatch !formattedValue:~-3! 096 07
    call :recpatch !formattedValue:~-3! 108 07
  )
  if %STEP2% == Y (
    call :trimpatch !formattedValue:~-3!
  )
)
goto :eof

:recpatch
echo Recording patch:%~1 note:%~2 ....
bin\sendmidi dev %MIDIOUT% dec pc %~1
start bin\sox -r 44.1k -c 2 -t waveaudio %AUDIOIN% record\%~1\i%~1n%~2.wav remix 1 trim 0 %~3
ping 2.2.2.2 -n 1 -w 1000 > nul
bin\sendmidi dev %MIDIOUT% dec on %~2 127
ping 2.2.2.2 -n 1 -w 500 > nul
timeout /t %~3 /nobreak
bin\sendmidi dev %MIDIOUT% dec off %~2 panic
ping 2.2.2.2 -n 1 -w 500 > nul
bin\sendmidi dev %MIDIOUT% dec off %~2
bin\sox -q -r 44.1k -c 2 -t waveaudio %AUDIOIN% test.wav remix 1 trim 0 0.5
ping 2.2.2.2 -n 1 -w 500 > nul
exit /b

:trimpatch
set attack=-
echo Trimming patch:%~1 ....
for /f %%f in ('dir /b/o-n record\%~1\*.wav') do (
  if !attack! == - (
    bin\sox record\%~1\%%f sfz\%~1\%%f silence 1 0.01 0.2 -1 0.1 0.02
    for %%h in (sfz\%~1\%%f) do (
      set size=%%~zh
      if !size! lss 441000 (
        set attack=Y
      ) else (
        bin\sox record\%~1\%%f sfz\%~1\%%f silence 1 0.01 0.2 -1 0.1 0.02 trim 0 !NATTLEN!
        set attack=N
      )
    )
  ) else if !attack! == Y (
    bin\sox record\%~1\%%f sfz\%~1\%%f silence 1 0.01 0.2 -1 0.1 0.02
  ) else (
    bin\sox record\%~1\%%f sfz\%~1\%%f silence 1 0.01 0.2 -1 0.1 0.02 trim 0 !NATTLEN!
  )
)
exit /b
